// Filter.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "ntool.h"
#include "Filter.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFilter _CAO


CFilter::CFilter(CWnd* pParent /*=NULL*/)
	: CDialog(CFilter::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFilter)
	m_cFilter = _T("");
	//}}AFX_DATA_INIT
	m_pConf = MConf::GetInstance();
}


void CFilter::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFilter)
	DDX_Control(pDX, IDC_LIST, m_cListCtrl);
	DDX_Text(pDX, IDC_FILTER, m_cFilter);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFilter, CDialog)
	//{{AFX_MSG_MAP(CFilter)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_DEL, OnDel)
	ON_NOTIFY(NM_CLICK, IDC_LIST, OnClickList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFilter bZ[W nh

CFilter::~CFilter()
{
	MConf::DeleteInstance();
}

BOOL CFilter::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	m_cListCtrl.InsertColumn(0,"tB^",LVCFMT_LEFT,300);

	for(int i= 0 ; i < m_pConf->GetFilterMax(); i++)
	{
		CString cFilter = m_pConf->GetFilter(i);
		m_cListCtrl.InsertItem(i,cFilter,0);
	}
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CFilter::OnAdd() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData();
	int i = m_cListCtrl.GetItemCount();
	m_cListCtrl.InsertItem(i,m_cFilter);
	m_cFilter = "";
	UpdateData(FALSE);
}

void CFilter::OnDel() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	POSITION pos = m_cListCtrl.GetFirstSelectedItemPosition();
	if (pos == NULL)
	   TRACE0("No items were selected!\n");
	else
	{

		int nItem = m_cListCtrl.GetNextSelectedItem(pos);
		m_cListCtrl.DeleteItem(nItem);
		m_cFilter = "";
		UpdateData(FALSE);
	}
	UpdateData(FALSE);
}

void CFilter::OnClickList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int nItem = GetSelected();
	m_cFilter =m_cListCtrl.GetItemText(nItem,0);
	UpdateData(FALSE);
	*pResult = 0;
}

int CFilter::GetSelected()
{
	
	int nItem = -1;
	POSITION pos = m_cListCtrl.GetFirstSelectedItemPosition();
	if (pos == NULL)
	   TRACE0("No items were selected!\n");
	else
	{

		nItem = m_cListCtrl.GetNextSelectedItem(pos);
	}
	return nItem;

}

void CFilter::Save()
{
	m_pConf->FilterClear();
	for(int i = 0 ; i < m_cListCtrl.GetItemCount() ; i++)
	{
		CString cFilter = m_cListCtrl.GetItemText(i,0);
		m_pConf->AddFilter(cFilter);
	}
}
