// LeftView.cpp : CLeftView NX̓̒`s܂B
//

#include "stdafx.h"
#include "ntool.h"

#include "ntoolDoc.h"
#include "LeftView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLeftView

IMPLEMENT_DYNCREATE(CLeftView, CTreeView)

BEGIN_MESSAGE_MAP(CLeftView, CTreeView)
	//{{AFX_MSG_MAP(CLeftView)
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, OnSelchanged)
	ON_NOTIFY_REFLECT(NM_RCLICK, OnRclick)
	ON_COMMAND(ID_DELETE, OnDelete)
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CTreeView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CTreeView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CTreeView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLeftView NX̍\z/

CLeftView::CLeftView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB

}

CLeftView::~CLeftView()
{
}

BOOL CLeftView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB
	cs.style = cs.style|TVS_HASLINES|TVS_LINESATROOT|TVS_HASBUTTONS;
	return CTreeView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CLeftView NX̕`

void CLeftView::OnDraw(CDC* pDC)
{
	CNtoolDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
}


/////////////////////////////////////////////////////////////////////////////
// CLeftView NẌ

BOOL CLeftView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}

void CLeftView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void CLeftView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}

void CLeftView::OnInitialUpdate()
{
	CTreeView::OnInitialUpdate();

	// TODO:  GetTreeCtrl() o֐̌ĂяoʂĒڂ̃Xg Rg[
	//  ANZX邱Ƃɂ TreeView ACeŌŒł܂B
	Refresh();



}

/////////////////////////////////////////////////////////////////////////////
// CLeftView NX̐ff

#ifdef _DEBUG
void CLeftView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CLeftView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}

CNtoolDoc* CLeftView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CNtoolDoc)));
	return (CNtoolDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CLeftView NX̃bZ[W nh
HTREEITEM CLeftView::Add(const CString &rTitle, int nChild, HTREEITEM hItem,int nData)
{
	TVINSERTSTRUCT TvItem;

	TvItem.hParent = hItem;
	TvItem.hInsertAfter = TVI_LAST;
	TvItem.item.mask = TVIF_CHILDREN | TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE;
	TvItem.item.pszText = (LPSTR)(LPCSTR)rTitle;
	TvItem.item.iImage = 0;
	TvItem.item.iSelectedImage = 1;
	TvItem.item.cChildren = nChild;
	HTREEITEM hRes =  GetTreeCtrl().InsertItem(&TvItem);

	GetTreeCtrl().SetItemData(hRes,nData);
	return hRes;
}

void CLeftView::OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// c[Rg[ւ̃|C^𓾂
	CTreeCtrl* pTree = (CTreeCtrl*)FromHandle(pNMHDR->hwndFrom);
	
	// Iꂽڂ𓾂
	HTREEITEM hItem = pTree->GetSelectedItem();
	if (hItem)
	{
		int nIndex = GetTreeCtrl().GetItemData(hItem);
		if(nIndex != -1)
		{
			CNtoolDoc *pDoc = GetDocument();
			if(pDoc != NULL)
			{
				MFile * pFile = pDoc->GetFile(nIndex);
				if(pFile == NULL){return;}
				CString cPath = pFile->GetPath();
				pDoc->OnOpenDocument(cPath);
			}else{
				DebugMsg("GetDocument()s");
			}
		}
		
	}
	*pResult = 0;
}

void CLeftView::OnRclick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CTreeCtrl *ctc=(CTreeCtrl *)CTreeCtrl::FromHandle(pNMHDR->hwndFrom);
	TV_HITTESTINFO info; 
	MSG *msg=(MSG *)GetCurrentMessage(); 
	 
	info.pt=msg->pt;
	ctc->ScreenToClient(&info.pt); 

	HTREEITEM hItem=ctc->HitTest(&info); 

	CPoint cPoint;
	cPoint = info.pt;

	ClientToScreen(&cPoint);
		
	CMenu menu;
	 //IDR_MENU1̕ɂ́A\ߍ쐬j[̖Ow肷
	menu.LoadMenu(IDR_PopMenu);
	CMenu *pMenu = menu.GetSubMenu(0);
	pMenu -> TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON,cPoint.x,cPoint.y,this);

	*pResult = (hItem!=0 && (info.flags & TVHT_ONITEMBUTTON)==0);//0;//

}

void CLeftView::OnDelete() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	// ӖɃ|C^ɕϊ
	CTreeCtrl *pTree = &GetTreeCtrl();
	HTREEITEM hItem = pTree->GetSelectedItem();
	if (hItem)
	{
		int nIndex = GetTreeCtrl().GetItemData(hItem);
		if(nIndex != -1)
		{
			CNtoolDoc *pDoc = GetDocument();
			if(pDoc != NULL)
			{
				MFile * pFile = pDoc->GetFile(nIndex);
				if(pFile == NULL)
				{
					DebugMsg("MFile擾s");
					return;
				}
				pFile->Delete();
				Refresh();
			}else{
				DebugMsg("GetDocument()s");
			}
		}
			
	}
}

void CLeftView::Refresh()
{
	if(GetDocument()->FindFile() == -1)
	{
		DebugMsg("e܂B");
		return;
	}

	// ӖɃ|C^ɕϊ
	CTreeCtrl *pTree = &GetTreeCtrl();

	// S폜āAc[ꂢɂ
	pTree->DeleteAllItems();

	// ܂̓[g}
	HTREEITEM hRoot = GetTreeCtrl().GetRootItem();

	// e̒ǉ
	HTREEITEM hLog = Add(_T("e"),1,hRoot,-1);

	// [vđŠeǉ
	HTREEITEM hMonth = NULL;	// ŐṼnhۑ
	CString cTitle,cMonth;
	for(int i=0 ; i < GetDocument()->GetFileCount();i++)
	{
		MFile* pFile = GetDocument()->GetFile(i);
		
		// OƈႤȂAtH_쐬
		CString cTempMonth = pFile->GetTime().Format("%m");
		if(cMonth != cTempMonth)
		{
			cMonth = cTempMonth;
			hMonth = Add(cMonth,1,hLog,-1);

		}
		Add(pFile->GetTime().Format("%d"),0,hMonth,i);
	}
	

	// c[WJ
	pTree->Expand(hRoot,TVE_EXPAND); // [g
	pTree->Expand(hLog ,TVE_EXPAND); // e
	pTree->Expand(hMonth,TVE_EXPAND); // ŐV
	
	
}
