// MainFrm.cpp : CMainFrame NX̓̒`s܂B
//

#include "stdafx.h"
#include "ntool.h"

#include "MainFrm.h"
#include "LeftView.h"
#include "ntoolView.h"

#include "TimeDlg.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_BUILD, OnBuild)
	ON_COMMAND(ID_DATEBUILD, OnDatebuild)
	ON_COMMAND(ID_ALLBUILD, OnAllbuild)
	ON_COMMAND(ID_SETTING, OnSetting)
	ON_COMMAND(ID_OPEN_AS, OnOpenAs)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Xe[^X C CWP[^
	ID_INDICATOR_KANA,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/

CMainFrame::CMainFrame()
{
	// TODO: ̈ʒuɃȍR[hǉĂB
	m_pDiary = new MnDiary;
	m_pConf = MConf::GetInstance();
	m_pDiary->Init();
}

CMainFrame::~CMainFrame()
{
	MConf::DeleteInstance();
	delete m_pDiary;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // 쐬Ɏs
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // 쐬Ɏs
	}

	// TODO: c[ o[hbLO\ɂȂꍇ͈ȉ̂Rs폜
	//       ĂB
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::OnCreateClient( LPCREATESTRUCT /*lpcs*/,
	CCreateContext* pContext)
{
	// EBhE쐬܂
	if (!m_wndSplitter.CreateStatic(this, 1, 2))
		return FALSE;

	if (!m_wndSplitter.CreateView(0, 0, RUNTIME_CLASS(CLeftView), CSize(100, 100), pContext) ||
		!m_wndSplitter.CreateView(0, 1, RUNTIME_CLASS(CNtoolView), CSize(100, 100), pContext))
	{
		m_wndSplitter.DestroyWindow();
		return FALSE;
	}

	return TRUE;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: ̈ʒu CREATESTRUCT cs CāAWindow NXX^C
	//       CĂB

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh


void CMainFrame::OnBuild() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	AfxGetApp()->SaveAllModified();
	m_pDiary->Compile(B_NORMAL);
}



void CMainFrame::OnDatebuild() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CTimeDlg cTime;

	if(cTime.DoModal() == IDOK)
	{
		CString cOption = cTime.m_cTime.Format("%Y%m");
		m_pDiary->Compile(B_DATE,cOption);
	}
}

void CMainFrame::OnAllbuild() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_pDiary->Compile(B_ALL);
}

void CMainFrame::OnSetting() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(m_cSettingDlg.DoModal() == IDOK)
	{}
}




void CMainFrame::OnOpenAs() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CString cPath = m_pConf->GetOutputDirectory();
	cPath += "\\" + m_pConf->GetLastestFileName();

	::ShellExecute(NULL,"open",cPath,NULL,NULL,SW_NORMAL);
}
