// PastDayDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "ntool.h"
#include "PastDayDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPastDayDlg _CAO


CPastDayDlg::CPastDayDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPastDayDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPastDayDlg)
	m_cDateFormat = _T("");
	m_cHeader = _T("");
	m_cMonthPart = _T("");
	m_cSkelton = _T("");
	m_cSplitTag = _T("");
	//}}AFX_DATA_INIT
	m_pConf = MConf::GetInstance();
}


void CPastDayDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPastDayDlg)
	DDX_Text(pDX, IDC_DATE_FORMAT, m_cDateFormat);
	DDX_Text(pDX, IDC_HEADER, m_cHeader);
	DDX_Text(pDX, IDC_MONTH_PART, m_cMonthPart);
	DDX_Text(pDX, IDC_SKELTON, m_cSkelton);
	DDX_Text(pDX, IDC_SPLIT_TAG, m_cSplitTag);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPastDayDlg, CDialog)
	//{{AFX_MSG_MAP(CPastDayDlg)
	ON_BN_CLICKED(IDC_SKELTON_REF, OnSkeltonRef)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPastDayDlg bZ[W nh

CPastDayDlg::~CPastDayDlg()
{
	MConf::DeleteInstance();
}

BOOL CPastDayDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	m_cDateFormat	= m_pConf->GetDateFormatPastDay();
	m_cHeader		= m_pConf->GetHeaderPastDay();
	m_cMonthPart	= m_pConf->GetMonthPartName();
	m_cSkelton	    = m_pConf->GetSkeltonPastDay();
	m_cSplitTag		= m_pConf->GetSplitPastDay();
	UpdateData(FALSE);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CPastDayDlg::Save()
{
	UpdateData();
	m_pConf->SetDateFormatPastDay(m_cDateFormat);
	m_pConf->SetHeaderPastDay(m_cHeader);
	m_pConf->SetMonthPartName(m_cMonthPart);
	m_pConf->SetSkeltonPastDay(m_cSkelton);
	m_pConf->SetSplitPastDay(m_cSplitTag);
	

}

void CPastDayDlg::OnSkeltonRef() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
		UpdateData();
	CFileDialog cDlg(TRUE,NULL,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
	"Htmlt@C(*.html,*.htm)|*.html;*.htm|ׂẴt@C(*.*)|*.*||");
	
	if(cDlg.DoModal() == IDOK)
	{
		m_cSkelton = cDlg.GetFileName();
	}
	UpdateData(FALSE);
}
