// ntoolDoc.cpp : CNtoolDoc NX̓̒`s܂B
//

#include "stdafx.h"
#include "ntool.h"

#include "ntoolDoc.h"
#include "ntoolView.h"
#include "TimeDlg.h"
#include "LeftView.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNtoolDoc

IMPLEMENT_DYNCREATE(CNtoolDoc, CDocument)

BEGIN_MESSAGE_MAP(CNtoolDoc, CDocument)
	//{{AFX_MSG_MAP(CNtoolDoc)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_COMMAND(ID_FILE_NEW_AS, OnFileNewAs)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNtoolDoc NX̍\z/

CNtoolDoc::CNtoolDoc()
:m_nCount(0),m_bFlag(FALSE)
{
	// TODO: ̈ʒuɂPxĂ΂\zp̃R[hǉĂB
	m_pSetting = MSetting::GetInstance();
	m_pConf = MConf::GetInstance();
}

CNtoolDoc::~CNtoolDoc()
{
	// ǗĂMFilẽ|C^S
	MSetting::DeleteInstance();
	MConf::DeleteInstance();
	FILE_ITERATOR i;
	
	for(i = m_liFile.begin(); i != m_liFile.end() ; i++)
	{
		delete *i;
	}

	
}

BOOL CNtoolDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	((CEditView*)m_viewList.GetHead())->SetWindowText(NULL);
	if(m_bFlag == FALSE)
	{
		m_bFlag = TRUE;
		return TRUE;
	}else{
		// TODO: ̈ʒuɍďǉĂB
		// (SDI hLg͂̃hLgėp܂B)
		MFile *pFile = new MFile;
		pFile ->SetDir(m_pConf->GetLogDirectory());
		pFile->Create(CTime::GetCurrentTime());
		m_liFile.push_back(pFile);
	}
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CNtoolDoc VAC[[V

void CNtoolDoc::Serialize(CArchive& ar)
{
	// CEditView ׂ͂ẴVAC[[V nĥǂꂩ̃GfBbgRg[܂ł܂B
	((CEditView*)m_viewList.GetHead())->SerializeRaw(ar);
}

/////////////////////////////////////////////////////////////////////////////
// CNtoolDoc NX̐ff

#ifdef _DEBUG
void CNtoolDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CNtoolDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CNtoolDoc R}h

int CNtoolDoc::FindFile()
{
	// ܂͌ȇ݂fBNg擾
	m_nCount = 0;
	ClearFile();
	CString cLogPath = m_pConf->GetLogDirectory();

	return FindFile(cLogPath + _T("\\*.diary"));

}

int CNtoolDoc::FindFile(LPCTSTR lpPath)
{
	// 
	CFileFind cFind;
	if(cFind.FindFile(lpPath) != 0)
	{
		int i = 1;
		CString cPath;
		MFile *pFile;
		while(i)
		{
			i = cFind.FindNextFile();

			if(cFind.IsDots()) continue;

			cPath = cFind.GetFilePath();
			if(cFind.IsDirectory())
			{
				FindFile(cPath);
			}else{
				pFile = new MFile;
				pFile->SetPath(cPath);
				m_liFile.push_back(pFile);
				m_nCount++;
			}
			
		}
	}else{
		// s
		return -1;
	}
	return 0;
}

int CNtoolDoc::GetFileCount()
{
	return m_nCount;
}

MFile* CNtoolDoc::GetFile(int nIndex)
{
	FILE_ITERATOR i = m_liFile.begin();

	for(int n = 0; n < nIndex ; n++)
	{
		i++;
	}

	return *i;

}

MFile* CNtoolDoc::GetFile(CTime cDate)
{
	FILE_ITERATOR i;

	for(i = m_liFile.begin(); i != m_liFile.end() ; i++)
	{
		MFile* pFile = *i;

		CTime cTime = pFile->GetTime();

		if(cTime == cDate)
		{
			return *i;
		}
	}
	return NULL;

}

BOOL CNtoolDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
/*	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
		*/
	
	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ
	POSITION pos = GetFirstViewPosition();
	while (pos != NULL)
	{
		CView* pView = GetNextView(pos);
		if (pView->IsKindOf(RUNTIME_CLASS(CNtoolView)))
		{
			((CNtoolView*)pView)->Open(lpszPathName);
			break;
		}
	}
	SetPathName(lpszPathName);
	return TRUE;
}

BOOL CNtoolDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	POSITION pos = GetFirstViewPosition();
	while (pos != NULL)
	{
		CView* pView = GetNextView(pos);
		if (pView->IsKindOf(RUNTIME_CLASS(CNtoolView)))
		{
			((CNtoolView*)pView)->Save(lpszPathName);
			break;
		}
	}
	
	// _[eBtO(ҏWꂽǂ̃tO)
	SetModifiedFlag(FALSE);
	//	return CDocument::OnSaveDocument(lpszPathName);
	return FALSE;
}

void CNtoolDoc::SetTitle(LPCTSTR lpszTitle) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	lpszTitle = _T("nTool v1.00");
	CDocument::SetTitle(lpszTitle);
}

void CNtoolDoc::ClearFile()
{
	FILE_ITERATOR i;
	
	for(i = m_liFile.begin(); i != m_liFile.end() ; i++)
	{
		delete *i;
	}
	m_liFile.clear();
}

void CNtoolDoc::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if(IsModified())
	{
		pCmdUI->Enable();
	}else{
		pCmdUI->Enable(FALSE);
	}
}

void CNtoolDoc::OnFileNewAs() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CTimeDlg cTime;
	cTime.m_cTime = CTime::GetCurrentTime();

	if(cTime.DoModal() == IDOK)
	{
		MFile *pFile = new MFile;
		pFile ->SetDir(m_pConf->GetLogDirectory());
		pFile->Create(cTime.m_cTime);
		m_liFile.push_back(pFile);
	

		POSITION pos = GetFirstViewPosition();
		while (pos != NULL)
		{
			CView* pView = GetNextView(pos);
			if (pView->IsKindOf(RUNTIME_CLASS(CLeftView)))
			{
				((CLeftView*)pView)->Refresh();
				break;
			}
		}
	}

}
