// Global.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "ntool.h"
#include "Global.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGlobal _CAO


CGlobal::CGlobal(CWnd* pParent /*=NULL*/)
	: CDialog(CGlobal::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGlobal)
	m_cLogPath = _T("");
	m_cOutPath = _T("");
	m_cTopicChar = _T("");
	m_bLF = FALSE;
	m_bVersion = FALSE;
	m_bAnchor = FALSE;
	m_bAnchorCount = FALSE;
	m_nKCode = -1;
	//}}AFX_DATA_INIT
	m_pConf = MConf::GetInstance();
}


void CGlobal::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGlobal)
	DDX_Text(pDX, IDC_LogPath, m_cLogPath);
	DDX_Text(pDX, IDC_OutPath, m_cOutPath);
	DDX_Text(pDX, IDC_TopicChar, m_cTopicChar);
	DDX_Check(pDX, IDC_LFtoBR, m_bLF);
	DDX_Check(pDX, IDC_Version, m_bVersion);
	DDX_Check(pDX, IDC_Anchor, m_bAnchor);
	DDX_Check(pDX, IDC_AnchorCont, m_bAnchorCount);
	DDX_Radio(pDX, IDC_KCode, m_nKCode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGlobal, CDialog)
	//{{AFX_MSG_MAP(CGlobal)
	ON_BN_CLICKED(IDC_LogBrowse, OnLogBrowse)
	ON_BN_CLICKED(IDC_OutBrowse, OnOutBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGlobal bZ[W nh

BOOL CGlobal::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	m_cLogPath = m_pConf->GetLogDirectory();
	m_cOutPath = m_pConf->GetOutputDirectory();
	m_bAnchor = m_pConf->GetParagraphAnchor();
	m_bAnchorCount = m_pConf->GetAnchorEachTopics();
	m_nKCode = (m_pConf->GetOutputKCode()-1);
	m_bAnchor = m_pConf->GetParagraphAnchor();
	m_bLF = m_pConf->GetLF2BR();
	m_bVersion = m_pConf->GetShowVersion();
	m_cTopicChar = m_pConf->GetTopicChar();
	UpdateData(FALSE);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

CGlobal::~CGlobal()
{
	MConf::DeleteInstance();
}

void CGlobal::Save()
{
	UpdateData();
	m_nKCode++;
	m_pConf->SetLogDirectory(m_cLogPath);
	m_pConf->SetOutputDirectory(m_cOutPath);
	m_pConf->SetAnchorEachTopics(m_bAnchorCount);
	m_pConf->SetOutputKCode(m_nKCode);
	m_pConf->SetLE2BR(m_bLF);
	m_pConf->SetShowVersion(m_bVersion);
	m_pConf->SetTopicChar(m_cTopicChar);
	m_pConf->SetParagraphAnchor(m_bAnchor);
	
}

void CGlobal::OnLogBrowse() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CShellControl cShell;
	CString cPath= cShell.RefFolder(GetSafeHwnd());
	if(cPath != _T(""))
	{
		m_cLogPath = cPath;
	}
	UpdateData(FALSE);
}

void CGlobal::OnOutBrowse() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CShellControl cShell;
	CString cPath= cShell.RefFolder(GetSafeHwnd());
	if(cPath != _T(""))
	{
		m_cOutPath = cPath;
	}
	UpdateData(FALSE);
}
