// FileApi.cpp: CFileApi NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FileApi.h"
#include <imagehlp.h>
#pragma comment(lib,"imagehlp.lib")

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CFileApi::CFileApi()
{

}

CFileApi::~CFileApi()
{

}

/*----------------------------------------------------------------------------*/
//  T  vF  Ɨp̃t@C擾
//    F  void
//  ߂lF  t@C̃tpX
//    lF  GetTempPath() + GetTempFileName()
/*----------------------------------------------------------------------------*/
CString CFileApi::GetTempPath()
{
	TCHAR tchPath[MAX_PATH + 1];
	if(::GetTempPath(MAX_PATH , tchPath) != 0)
	{
		// t@C̎擾
		TCHAR tchFileName[MAX_PATH +1 ];
		GetTempFileName(tchPath , "AIR",0,tchFileName);
		return tchFileName;
	}else{
		return "";
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  tH_ǂ`FbN
//    F  tpX
//  ߂lF  tH_ / t@C == TRUE / FALSE
//    lF  void
/*----------------------------------------------------------------------------*/
BOOL CFileApi::CheckDirectory(LPCTSTR lpPath)
{
	DWORD dwType = ::GetFileAttributes(lpPath);

	if(dwType & FILE_ATTRIBUTE_DIRECTORY && dwType != 0xFFFFFFFF)
	{
		// ݂āAtH_̏ꍇ
		return TRUE;
	}else{
		return FALSE;
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  tH_ċNIɍ폜
//    F  tH_̃pX
//  ߂lF   == TRUE
//    lF  void
/*----------------------------------------------------------------------------*/
BOOL CFileApi::DeleteDirectory(LPCTSTR lpPathName)
{
	CFileFind fnd;
    CString strPathName = lpPathName;
    strPathName.TrimRight('\\');
    strPathName += _T("\\*.*");
    if(fnd.FindFile(strPathName, 0))
    {
        int i = 1;
        while(i)
        {
            i = fnd.FindNextFile();

            // t@C"."".."̏ꍇ͎
            if(fnd.IsDots())
                continue;

            // 폜t@C擾
            // GetFilePath()ɂ̓oO萳mɎ擾łȂꍇ̂ŎgȂ
            CString strDeleteFile = lpPathName;
            strDeleteFile.TrimRight('\\');
            strDeleteFile += _T("\\") + fnd.GetFileName();

            // tH_ꍇAċAĂяoł̃tH_폜
            if(fnd.IsDirectory())
                DeleteDirectory(strDeleteFile);

            // t@C̍폜
            else
			{
                int i = ::DeleteFile(strDeleteFile);
				DWORD dw = GetLastError();
			}
			
        }
        fnd.Close();

        // tH_̍폜
		CString cPath;
		cPath = lpPathName;
		cPath.TrimRight('\\');
        return ::RemoveDirectory(cPath);
    }

	return FALSE;
}

/*----------------------------------------------------------------------------*/
//  T  vF  tH_łt@Cł폜
//    F  tpX
//  ߂lF   == 0
//    lF  void
/*----------------------------------------------------------------------------*/
int CFileApi::Delete(LPCTSTR lpPath)
{
	if(CheckDirectory(lpPath))
	{
		return DeleteDirectory(lpPath);
	}else{
		return ::DeleteFile(lpPath);
	}
}

/*----------------------------------------------------------------------------*/
//  T  vF  st@C̃tpX擾
//    F  void
//  ߂lF  tpX
//    lF  void
/*----------------------------------------------------------------------------*/
CString CFileApi::GetMyPath()
{
	TCHAR tchPath[MAX_PATH +1];
	::GetModuleFileName(NULL , tchPath , MAX_PATH);

	return tchPath;
}

//----------------------------------------------------------------------------//
//  T  vF  t@C𐶐
//    F  pX
//  ߂lF  0 =  , -1 = s
//    lF  
//----------------------------------------------------------------------------//
int CFileApi::CreateFile(LPCTSTR lpPath)
{
	CFile cFile(lpPath,CFile::modeCreate);
	cFile.Close();
	return 0;
}

//----------------------------------------------------------------------------//
//  T  vF  fBNg̐
//    F  pX
//  ߂lF  0 =  , -1 = s
//    lF  
//----------------------------------------------------------------------------//
int CFileApi::CreateDir(LPCTSTR lpPath)
{
	CString cPath = lpPath;
	cPath.TrimRight(_T("\\"));
	cPath += _T("\\");
	if(MakeSureDirectoryPathExists(cPath) == FALSE)
	{
		DWORD dw = GetLastError();
		return -1;
	}else{
		return 0;
	}
}	

//----------------------------------------------------------------------------//
//  T  vF  tH_Rs[
//    F  lpOldPath = ÂpX , lpNewPath = VpX
//  ߂lF  0 =  , -1 = s
//    lF  
//----------------------------------------------------------------------------//
int CFileApi::CopyFolder(LPCTSTR lpOldPath, LPCTSTR lpNewPath)
{
	// ܂́AlpOldPath݂邩`FbN
	DWORD dwType = ::GetFileAttributes(lpOldPath);
	if(dwType & FILE_ATTRIBUTE_DIRECTORY && dwType == 0xFFFFFFFF)
	{
		// ݂ȂAtH_łȂB
		// ǂɂG[
		return -1;
	}else{
		return CopyFolder(lpOldPath,lpNewPath,lpNewPath);
	}

}

//----------------------------------------------------------------------------//
//  T  vF  tH_Rs[
//    F  lpOldPath = ÂpX , lpNewPath = VpX , 
//			@lpRootPath = Rs[̊ƂȂpX
//  ߂lF  0 =  , -1 = s
//    lF  J֐
//----------------------------------------------------------------------------//
int CFileApi::CopyFolder(LPCTSTR lpOldPath, LPCTSTR lpNewPath, LPCTSTR lpRootPath)
{
	// A߂ǂ`
	// XpQbeBɂȂ̊oőg݂܂B
	
	// ܂́A₷CString^ɕϊ
	CString cOldPath = lpOldPath;
	CString cNewPath = lpNewPath;

	// t@Č
	CFileFind cFind;
	if(cFind.FindFile(cOldPath + _T("\\*.*")) == 0)
	{
		cFind.Close();
		return -1;
	}

	//  & [vJn
	int i = 1;
	while(i)
	{
		i = cFind.FindNextFile();

		// hbg͖
		if(cFind.IsDots())
		{
			continue;
		}


		if(cFind.IsDirectory())
		{
			// fBNg̏ꍇ
			// ܂́AꂽtH_擾
			CString cPath = cFind.GetFilePath();
			
			// VpXɕϊ
			TRACE("ϊO:%s\n",cPath);
			cPath.Replace(cOldPath,cNewPath);
			TRACE("ԊҌ:%s\n",cPath);

			// ŁAċNIɌĂяoB
			CreateDir(cPath + _T("\\"));
			CopyFolder(cFind.GetFilePath() , cPath,lpRootPath);
		}else{
			// t@C̏ꍇ
			// ͂ƂAt@C̃pX̎擾
			CString cPath = cFind.GetFilePath();

			// ŁARs[̃t@C擾
			CString cNewFile;
			cNewFile = cNewPath + _T("\\") + cFind.GetFileName();

			

			// ŃRs[
			CopyFile(cPath,cNewFile,FALSE);
		}
	}

	cFind.Close();
	return 0;
}
