// LastestDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "ntool.h"
#include "LastestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLastestDlg _CAO


CLastestDlg::CLastestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLastestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLastestDlg)
	m_cFileName = _T("");
	m_cHeader = _T("");
	m_nMaxCount = 0;
	m_cSkelton = _T("");
	m_cSplit = _T("");
	m_cDateFormat = _T("");
	//}}AFX_DATA_INIT
	m_pConf = MConf::GetInstance();
}


void CLastestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLastestDlg)
	DDX_Text(pDX, IDC_FILENAME, m_cFileName);
	DDX_Text(pDX, IDC_HEADER, m_cHeader);
	DDX_Text(pDX, IDC_MAX_COUNT, m_nMaxCount);
	DDX_Text(pDX, IDC_SKELTON, m_cSkelton);
	DDX_Text(pDX, IDC_SPLIT_TAG, m_cSplit);
	DDX_Text(pDX, IDC_DATE_FORMAT, m_cDateFormat);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLastestDlg, CDialog)
	//{{AFX_MSG_MAP(CLastestDlg)
	ON_BN_CLICKED(IDC_OUT_REF, OnOutRef)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLastestDlg bZ[W nh

BOOL CLastestDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_cFileName = m_pConf->GetLastestFileName();
	m_cHeader = m_pConf->GetHeaderLastest();
	m_cSkelton = m_pConf->GetSkeltonLastest();
	m_cSplit = m_pConf->GetSplitLastest();
	m_nMaxCount = m_pConf->GetMaxDiary();
	m_cDateFormat = m_pConf->GetDateFormatLastest();
	UpdateData(FALSE);
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

CLastestDlg::~CLastestDlg()
{
	MConf::DeleteInstance();
}

void CLastestDlg::Save()
{
	UpdateData();

	m_pConf->SetLastestFileName(m_cFileName);
	m_pConf->SetHeaderLastest(m_cHeader);
	m_pConf->SetSkeltonLastest(m_cSkelton);
	m_pConf->SetSplitLastest(m_cSplit);
	m_pConf->SetMaxDiary(m_nMaxCount);
	m_pConf->SetDateFormatLastest(m_cDateFormat);
}

void CLastestDlg::OnOutRef() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData();
	CFileDialog cDlg(TRUE,NULL,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"HTML t@C(*.html,*htm)|*.html;*.htm||");
	
	if(cDlg.DoModal() == IDOK)
	{
		m_cSkelton = cDlg.GetFileName();
	}
	UpdateData(FALSE);
}
