// MConf.h: MConf NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MCONF_H__46A0201E_49EB_468E_9149_AEB2ECA45C6B__INCLUDED_)
#define AFX_MCONF_H__46A0201E_49EB_468E_9149_AEB2ECA45C6B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "map"
#include "list"
using namespace std;

typedef struct _TOPICS{
	CString cKey;
	CString cFile;
}TOPICS;

class MSetting;
class MConf  
{
/**
Tv        F  nDiary.confǗ
֘AtH[F  Ȃ
l        F  nDiaryXNvg̐ݒ
*/
public:
	virtual int GetFilterMax();
	virtual void FilterClear();
	virtual void ClearTopcs();
	virtual int GetTopicsCount();
	int SetHeaderPastDay(const CString &rHeader);
	virtual CString GetSkeltonPastDay();
	virtual void WriteFile();
	virtual int SetTopics(CString cKey,CString cData);
	virtual int GetTopics(int nIndex,CString& rKey,CString &rData);
	virtual int SetAnchorEachTopics(BOOL b);
	virtual BOOL GetAnchorEachTopics();
	virtual int AddFilter(CString cFilter);
	virtual CString GetFilter(int nIndex);
	virtual int SetTopicDateFormat(const CString& rFormat);
	virtual CString GetTopicDateFormat();
	virtual int SetTopicMonthFormat(const CString &rFormat);
	virtual CString GetTopicMonthFormat();
	virtual int SetSplitPastDay(const CString& rSplit);
	virtual CString GetSplitPastDay();
	virtual int SetSkeltonPastDay(const CString &rSkelton);
	virtual CString GetHeaderPastDay();
	virtual int SetDateFormatPastDay(const CString& rFormat);
	virtual CString GetDateFormatPastDay();
	virtual int SetMonthPartName(const CString& rName);
	virtual CString GetMonthPartName();
	virtual int SetSplitLastest(const CString& rSplit);
	virtual CString GetSplitLastest();
	virtual int SetSkeltonLastest(const CString& rSkelton);
	virtual CString GetSkeltonLastest();
	virtual CString GetHeaderLastest();
	virtual int SetHeaderLastest(const CString& rHeader);
	virtual CString GetDateFormatLastest();
	virtual int SetDateFormatLastest(const CString &rFormat);
	virtual CString GetLastestFileName();
	virtual int SetLastestFileName(const CString& rPath);
	virtual int GetMaxDiary();
	virtual int SetMaxDiary(int nMax);
	virtual void AddQuote(CString &rBuf);
	/// ''ł

	virtual int SetShowVersion(BOOL b);
	virtual BOOL GetShowVersion();
	/// # nDiary ̃@[W̕\(true / false)

	virtual int SetOutputKCode(int nCode);
	virtual int GetOutputKCode();
	/// # o͊R[h(JIS = 1 / EUC = 2 / SJIS = 3)

	virtual int SetLE2BR(BOOL b);
	virtual BOOL GetLF2BR();
	/// # s <br> ɕϊ邩ǂ (true / false)

	virtual int SetParagraphAnchor(BOOL b);
	virtual BOOL GetParagraphAnchor();
	/// # ĩAJ[gsbNɃJEg (true / false)
	
	virtual int SetTopicChar(const CString &rData);
	virtual CString GetTopicChar();
	/// # gsbN(o)̍s

	int SetOutputDirectory(const CString& rPath);
	virtual CString GetOutputDirectory();
	/// # htmlt@Co͂fBNg

	virtual int SetLogDirectory(const CString &rPath);
	virtual int ReadTopics(const CString& rData);
	/**
	T  vF  gsbNXǂ݂Ƃ
	  F  ͂镶
	߂lF@
	  lF  f[^m_mTopicsɕۑ
	*/
	virtual int ReadFilter(const CString& rData);
	/**
	T  vF  tB^ǂ݂Ƃ
	  F  ͂镶
	߂lF@Ȃ
	  lF  f[^m_mFilter
	*/
	virtual void ReadFile();
	/**
	T  vF  ndiary.conff[^ǂ݂Ƃ
	  F  Ȃ
	߂lF@
	  lF  ǂ݂Ƃf[^m_mDataɕۑ
	*/
	static void DeleteInstance();
	/**
	T  vF  
	  F  
	߂lF@ = 0
	  lF  
	*/
	static MConf* GetInstance();
	/**
	T  vF  
	  F  
	߂lF@ = 0
	  lF  
	*/
	virtual CString GetLogDirectory();
	/**
	T  vF@L݂̑fBNg擾 
	  F  
	߂lF@L݂̑fBNg
	  lF  
	*/
	virtual int SetPath(const CString &rPath);
	/**
	T  vF  pXݒ肷
	  F  pX
	߂lF@ = 0
	  lF  
	*/
	virtual CString GetPath();
	/**
	T  vF  pX擾
	  F  Ȃ
	߂lF@pX
	  lF  
	*/
	MConf();
	virtual ~MConf();

private:
	int m_nTopicsMax;
	int m_nFilterMax;
	CString m_cPath;
	MSetting* m_pSetting;
	static MConf* m_pConf;
	static int m_nRef;
	map<CString , CString> m_mData;
	/// ݒ肳ꂽf[^
	list<CString> m_liFilter;
	/// ݒ肳ĂtB^
	list<TOPICS> m_liTopics;
	/// ݒ肳ĂgsbNX

protected:
	virtual void DelQuote(CString &rStr);
};

#endif // !defined(AFX_MCONF_H__46A0201E_49EB_468E_9149_AEB2ECA45C6B__INCLUDED_)
