// MainDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "ntool.h"
#include "MainDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainDlg _CAO


CMainDlg::CMainDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMainDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMainDlg)
	m_cConfPath = _T("");
	m_cDiaryPath = _T("");
	m_cRubyPath = _T("");
	//}}AFX_DATA_INIT
	m_pSetting = MSetting::GetInstance();
}


void CMainDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMainDlg)
	DDX_Text(pDX, IDC_CONF_PATH, m_cConfPath);
	DDX_Text(pDX, IDC_DIAYR_PATH, m_cDiaryPath);
	DDX_Text(pDX, IDC_RUBY_PATH, m_cRubyPath);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMainDlg, CDialog)
	//{{AFX_MSG_MAP(CMainDlg)
	ON_BN_CLICKED(IDC_CONF_REF, OnConfRef)
	ON_BN_CLICKED(IDC_RUBY_REF, OnRubyRef)
	ON_BN_CLICKED(IDC_DIARY_REF, OnDiaryRef)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainDlg bZ[W nh

CMainDlg::~CMainDlg()
{
	MSetting::DeleteInstance();
}

BOOL CMainDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	m_cConfPath = m_pSetting->GetConfPath();
	m_cDiaryPath = m_pSetting->GetnDiaryPath();
	m_cRubyPath = m_pSetting->GetRubyPath();
	UpdateData(FALSE);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CMainDlg::Save()
{
	UpdateData();

	m_pSetting->SetConfPath(m_cConfPath);
	m_pSetting->SetnDiaryPath(m_cDiaryPath);
	m_pSetting->SetRubyPath(m_cRubyPath);
}

void CMainDlg::OnConfRef() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData();
	CFileDialog cDlg(TRUE,NULL,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
	"ndiary.conf|*.conf|ׂẴt@C(*.*)|*.*||");
	
	if(cDlg.DoModal() == IDOK)
	{
		m_cConfPath = cDlg.GetPathName();
	}
	UpdateData(FALSE);
}

void CMainDlg::OnRubyRef() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData();
	CFileDialog cDlg(TRUE,NULL,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
	"ruby.exe|*.exe|ׂẴt@C(*.*)|*.*||");
	
	if(cDlg.DoModal() == IDOK)
	{
		m_cRubyPath = cDlg.GetPathName();
	}
	UpdateData(FALSE);
}

void CMainDlg::OnDiaryRef() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData();
	CFileDialog cDlg(TRUE,NULL,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
	"ׂẴt@C(*.*)|*.*||");
	
	if(cDlg.DoModal() == IDOK)
	{
		m_cDiaryPath = cDlg.GetPathName();
	}
	UpdateData(FALSE);
}
