// MnDiary.cpp: MnDiary NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ntool.h"
#include "MnDiary.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

MnDiary::MnDiary()
{

}

MnDiary::~MnDiary()
{
	MSetting::DeleteInstance();
	MConf::DeleteInstance();
	delete m_pRuby;
}

void MnDiary::Init()
{
	// ݒ̃|C^擾
	m_pSetting = MSetting::GetInstance();
	
	// eNX𐶐
	m_pRuby = new MRuby;
	m_pConf = MConf::GetInstance();
	
	// eNX̏
	m_pRuby->Init();

	// ŏݒs
	m_cPath = m_pSetting->GetnDiaryPath();
}

int MnDiary::SetPath(const CString &rPath)
{
	m_cPath = rPath;
	return 0;
}

CString MnDiary::GetPath()
{
	return m_cPath;
}

int MnDiary::Compile(int nMode,const CString& rOption)
{
	/* RubyɃXNvgs
	   ̍ۂ̃R}hC
	 
	   [XNvg̃pX] [nDiary.conf̃pX] [IvV]
	*/
	CFileString cStr;
	CString cDir = cStr.GetDirName(m_cPath);
	CString cCmdLine;
	CString cConfPath =  m_pConf->GetPath();

	switch(nMode)
	{
	case B_NORMAL:
		cCmdLine = m_cPath +_T(" ") +cConfPath;
		break;
	case B_DATE:
		cCmdLine = m_cPath +_T(" ") +cConfPath +_T(" ") + rOption;
		break;
	case B_ALL:
		cCmdLine = m_cPath +_T(" ") +cConfPath + _T(" all");
		break;
	case B_CONF:
		cCmdLine = m_cPath +_T(" ") + rOption;
		break;
	}
	// s
	if(SetCurrentDirectory(cDir) == 0)
	{
		DWORD dw = GetLastError();
	}
	return m_pRuby->Execute(cCmdLine);
}

MConf* MnDiary::Setting()
{
	return m_pConf;
}
