// SettingDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "ntool.h"
#include "SettingDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSettingDlg _CAO


CSettingDlg::CSettingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSettingDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSettingDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
	m_pConf=MConf::GetInstance();
}


void CSettingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettingDlg)
	DDX_Control(pDX, IDC_MainTab, m_cTabCtrl);
	DDX_Control(pDX, IDC_MainTree, m_cTreeCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSettingDlg, CDialog)
	//{{AFX_MSG_MAP(CSettingDlg)
	ON_NOTIFY(TVN_SELCHANGING, IDC_MainTree, OnSelchangingMainTree)
	ON_NOTIFY(TVN_SELCHANGED, IDC_MainTree, OnSelchangedMainTree)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettingDlg bZ[W nh

BOOL CSettingDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	// _CAȌ
	m_cGlobalDlg.Create(IDD_GLOBAL,&m_cTabCtrl);
	m_cGlobalDlg.ShowWindow(SW_HIDE);

	m_cLastestDlg.Create(IDD_LASTEST,&m_cTabCtrl);
	m_cLastestDlg.ShowWindow(SW_HIDE);

	m_cPastDayDlg.Create(IDD_PAST_DAY,&m_cTabCtrl);
	m_cPastDayDlg.ShowWindow(SW_HIDE);

	m_cTopics.Create(IDD_TOPICS,&m_cTabCtrl);
	m_cTopics.ShowWindow(SW_HIDE);

	m_cMainDlg.Create(IDD_MAIN,&m_cTabCtrl);
	m_cMainDlg.ShowWindow(SW_SHOW);

	m_cFilterDlg.Create(IDD_FILTER,&m_cTabCtrl);

	// c[ɒǉ
	HTREEITEM hRoot = m_cTreeCtrl.GetRootItem();

	CString nDiary,cLastest,cPastDay,cTopics,cMain,cFilter;

	nDiary.LoadString(IDS_DIARY);
	cLastest.LoadString(IDS_LASTESTDIARY);
	cPastDay.LoadString(IDS_PASTDAY);
	cTopics.LoadString(IDS_TOPIC);
	cMain.LoadString(IDS_NTOOL);
	cFilter.LoadString(IDS_FILTER);

	HTREEITEM hTool  = AddTree(hRoot,cMain);
	HTREEITEM hDiary = AddTree(hRoot,nDiary,1);
	
	AddTree(hDiary,cLastest);
	AddTree(hDiary,cPastDay);
	AddTree(hDiary,cTopics);
	AddTree(hDiary,cFilter);

	m_cTreeCtrl.Expand(hDiary,TVE_EXPAND);
	m_cTreeCtrl.Select(hTool,TVGN_CARET);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CSettingDlg::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	m_cGlobalDlg.Save();
	m_cLastestDlg.Save();
	m_cPastDayDlg.Save();
	m_cTopics.Save();
	m_cFilterDlg.Save();
	m_pConf->WriteFile();

	m_cMainDlg.Save();
	CDialog::OnOK();
}



HTREEITEM CSettingDlg::AddTree(HTREEITEM hItem, const CString &rTitle, int nChild, int nData)
{
	TVINSERTSTRUCT TvItem;

	TvItem.hParent = hItem;
	TvItem.hInsertAfter = TVI_LAST;
	TvItem.item.mask = TVIF_CHILDREN | TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE;
	TvItem.item.pszText = (LPSTR)(LPCSTR)rTitle;
	TvItem.item.iImage = 0;
	TvItem.item.iSelectedImage = 1;
	TvItem.item.cChildren = nChild;
	HTREEITEM hRes =  m_cTreeCtrl.InsertItem(&TvItem);

	m_cTreeCtrl.SetItemData(hRes,nData);
	return hRes;
}

void CSettingDlg::OnSelchangingMainTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
		CTreeCtrl* pTree = (CTreeCtrl*)FromHandle(pNMHDR->hwndFrom);
	
	// Iꂽڂ𓾂
	HTREEITEM hItem = pTree->GetSelectedItem();
	if (!hItem){ *pResult = 0; } 

	CString cTitle = pTree->GetItemText(hItem);

	CString nDiary,cLastest,cPastDay,cTopics,cMain,cFilter;

	nDiary.LoadString(IDS_DIARY);
	cLastest.LoadString(IDS_LASTESTDIARY);
	cPastDay.LoadString(IDS_PASTDAY);
	cTopics.LoadString(IDS_TOPIC);
	cMain.LoadString(IDS_NTOOL);
	cFilter.LoadString(IDS_FILTER);

	if(cTitle == nDiary)
	{
		m_cGlobalDlg.ShowWindow(SW_HIDE);
	}
	else if(cTitle == cLastest)
	{
		m_cLastestDlg.ShowWindow(SW_HIDE);
	}
	else if(cTitle == cPastDay)
	{
		m_cPastDayDlg.ShowWindow(SW_HIDE);
	}
	else if(cTitle == cTopics)
	{
		m_cTopics.ShowWindow(SW_HIDE);
	}
	else if(cTitle == cMain)
	{
		m_cMainDlg.ShowWindow(SW_HIDE);
	}
	else if(cTitle == cFilter)
	{
		m_cFilterDlg.ShowWindow(SW_HIDE);
	}
}

void CSettingDlg::OnSelchangedMainTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CTreeCtrl* pTree = (CTreeCtrl*)FromHandle(pNMHDR->hwndFrom);
	
	// Iꂽڂ𓾂
	HTREEITEM hItem = pTree->GetSelectedItem();
	if (!hItem){ *pResult = 0; } 

	CString cTitle = pTree->GetItemText(hItem);

	CString nDiary,cLastest,cPastDay,cTopics,cMain,cFilter;

	nDiary.LoadString(IDS_DIARY);
	cLastest.LoadString(IDS_LASTESTDIARY);
	cPastDay.LoadString(IDS_PASTDAY);
	cTopics.LoadString(IDS_TOPIC);
	cMain.LoadString(IDS_NTOOL);
	cFilter.LoadString(IDS_FILTER);

	if(cTitle == nDiary)
	{
		m_cGlobalDlg.ShowWindow(SW_SHOW);
	}else if(cTitle == cLastest)
	{
		m_cLastestDlg.ShowWindow(SW_SHOW);
	}
	else if(cTitle == cPastDay)
	{
		m_cPastDayDlg.ShowWindow(SW_SHOW);
	}
	else if(cTitle == cTopics)
	{
		m_cTopics.ShowWindow(SW_SHOW);
	}
	else if(cTitle == cMain)
	{
		m_cMainDlg.ShowWindow(SW_SHOW);
	}
	else if(cTitle == cFilter)
	{
		m_cFilterDlg.ShowWindow(SW_SHOW);
	}
}

CSettingDlg::~CSettingDlg()
{
	MConf::DeleteInstance();
}
