// Topics.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "ntool.h"
#include "Topics.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTopics _CAO


CTopics::CTopics(CWnd* pParent /*=NULL*/)
	: CDialog(CTopics::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTopics)
	m_cDateFormat = _T("");
	m_cFileName = _T("");
	m_cKey = _T("");
	m_cMonthFormat = _T("");
	//}}AFX_DATA_INIT
	m_pConf = MConf::GetInstance();
}


void CTopics::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTopics)
	DDX_Control(pDX, IDC_LIST, m_cListCtrl);
	DDX_Text(pDX, IDC_DATE_FORMAT, m_cDateFormat);
	DDX_Text(pDX, IDC_FILENAME, m_cFileName);
	DDX_Text(pDX, IDC_KEY, m_cKey);
	DDX_Text(pDX, IDC_MONTH_FORMAT, m_cMonthFormat);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTopics, CDialog)
	//{{AFX_MSG_MAP(CTopics)
	ON_NOTIFY(HDN_ITEMCLICK, IDC_LIST, OnItemclickList)
	ON_NOTIFY(NM_CLICK, IDC_LIST, OnClickList)
	ON_BN_CLICKED(IDC_DELL, OnDell)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_EN_KILLFOCUS(IDC_KEY, OnKillfocusKey)
	ON_EN_KILLFOCUS(IDC_FILENAME, OnKillfocusFilename)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTopics bZ[W nh

CTopics::~CTopics()
{
	MConf::DeleteInstance();
}

BOOL CTopics::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	m_cListCtrl.InsertColumn(0,"t@C",LVCFMT_LEFT,150);
	m_cListCtrl.InsertColumn(1,"o",LVCFMT_LEFT,150);

	m_cDateFormat = m_pConf->GetTopicDateFormat();
	m_cMonthFormat = m_pConf->GetTopicMonthFormat();

	CString cFile,cKey;
	if(m_pConf->GetTopicsCount() == 0)
	{
		return TRUE;
	}
	for(int i = 0 ; i < m_pConf->GetTopicsCount() ; i++)
	{
		// ܂́At@Cƒo擾
		if(m_pConf->GetTopics(i,cKey,cFile) == -1)
		{
			DebugMsg("Ƃ҂̎擾ɂς܂");
			return TRUE;
		}

		Add(cFile,cKey);
	}

	UpdateData(FALSE);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CTopics::Save()
{
	UpdateData();
	m_pConf->SetTopicDateFormat(m_cDateFormat);
	m_pConf->SetTopicMonthFormat(m_cMonthFormat);
	m_pConf->ClearTopcs();
	
	CString cFile,cKey;
	for(int i = 0;i < m_cListCtrl.GetItemCount() ; i++)
	{
		cFile= m_cListCtrl.GetItemText(i,0);
		cKey  = m_cListCtrl.GetItemText(i,1);

		m_pConf->SetTopics(cKey,cFile);
	}
}

void CTopics::OnItemclickList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	HD_NOTIFY *phdn = (HD_NOTIFY *) pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	*pResult = 0;
}

void CTopics::OnClickList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int nItem = GetSelected();
	m_cFileName = m_cListCtrl.GetItemText(nItem,0);
	m_cKey  = m_cListCtrl.GetItemText(nItem,1);
	UpdateData(FALSE);

	*pResult = 0;
}

void CTopics::OnDell() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int nItem = GetSelected();
	m_cListCtrl.DeleteItem(nItem);
	m_cFileName = _T("");
	m_cKey = _T("");
	UpdateData(FALSE);
}

void CTopics::OnAdd() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData();
	Add(m_cFileName,m_cKey);

	m_cFileName = _T("");
	m_cKey = _T("");
	UpdateData(FALSE);
}

int CTopics::GetSelected()
{
	int nItem = -1;
	POSITION pos = m_cListCtrl.GetFirstSelectedItemPosition();
	if (pos == NULL)
	   TRACE0("No items were selected!\n");
	else
	{

		nItem = m_cListCtrl.GetNextSelectedItem(pos);
	}
	return nItem;
}

void CTopics::Add(CString cFile, CString cKey,int nIndex)
{
	
	int i = m_cListCtrl.GetItemCount();
	if(nIndex != -1)
	{
		i = nIndex;
	}
	int nItem = m_cListCtrl.InsertItem(i,cFile);
	m_cListCtrl.SetItem(nItem,1,LVIF_TEXT ,cKey,0,0,0,0);


}

void CTopics::OnKillfocusKey() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	

}

void CTopics::OnKillfocusFilename() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

}
